'''
Advanced Power Abstract Bluetooth Wrapper
2008-2010(c) Kirill Plyashkevich <ru.spirit@gmail.com>
'''

from wrappers.AbstractWrappers import AbstractWrapper

class AbstractBluetooth(AbstractWrapper):

  def __init__(self, bus, check = False):
    self.mode = 'unknown'
    self.available_modes = ['unknown'] 
    AbstractWrapper.__init__(self, bus, check)

  def post_init(self):
    pass

  def mode_handler(self, *args):
    raise NotImplementedError("AbstractBluetooth.mode_handler(*args) must be implemented")

  def get_mode(self):
    raise NotImplementedError("AbstractBluetooth.get_mode() must be implemented")

  def set_mode(self, mode):
    raise NotImplementedError("AbstractBluetooth.set_mode(mode) must be implemented")

  def get_available_modes(self):
    raise NotImplementedError("AbstractBluetooth.get_available_modes() must be implemented")
