'''
Advanced Power Bluetooth Wrapper BlueZ
2009-2010(c) Kirill Plyashkevich <ru.spirit@gmail.com>
'''

from Util import Shell
from wrappers.bluetooth.AbstractBluetooth import AbstractBluetooth

class BluetoothBlueZ_Maemo5(AbstractBluetooth):

  def pre_init(self):
    self.friendly_name = 'BlueZ Maemo 5'
    self.dep_packages = {'bluez': '4.53'}
    adapter = Shell.get_command_output('dbus-send --system --dest=org.bluez --print-reply /org/bluez org.bluez.Manager.DefaultAdapter | tail -1 | sed \'s/^.*"\\(.*\\)".*$/\\1/\'').replace('\n', '')
    self.interfaces_map = {'BlueZ': ('org.bluez', adapter, 'org.bluez.Adapter')}
    self.export_signals = {'bluetooth_mode': {'path': adapter, 'dbus_interface': 'org.bluez.Adapter', 'signal_name': 'PropertyChanged'}}

  def get_mode_dbus(self, powered=None, discoverable=None):
    try:
      if powered == None:
        powered = self.interfaces['BlueZ'].GetProperty('Powered')
      if powered:
        if discoverable == None:
          discoverable = self.interfaces['BlueZ'].GetProperty('Discoverable')
        if discoverable:
          self.mode = 'discoverable'
        else:
          self.mode = 'connectable'
      else:
        self.mode = 'off'
    except:
      pass

  def set_mode_dbus(self, mode):
    try:
      powered = mode != 'off'
      self.interfaces['BlueZ'].SetProperty('Powered', powered)
      if powered: 
        self.interfaces['BlueZ'].SetProperty('Discoverable', mode == 'discoverable')
    except:
      pass

  def get_status(self):
    self.get_mode_dbus()
    self.available_modes = ['off', 'connectable', 'discoverable']

  def mode_handler(self, name, value):
    name = str(name)
    if name in ['Powered', 'Discoverable']:
      value = bool(value)
      if name == 'Powered':
        self.get_mode_dbus(powered=value)
      elif name == 'Discoverable':
        self.get_mode_dbus(discoverable=value)

  def get_mode(self):
    return self.mode

  def set_mode(self, mode):
    try:
      self.set_mode_dbus(mode)
      self.get_mode_dbus()
    except:
      pass

  def get_available_modes(self):
    return self.available_modes
