'''
Advanced Power Bluetooth Wrapper BlueZ
2009-2010(c) Kirill Plyashkevich <ru.spirit@gmail.com>
'''

from Util import Shell
from wrappers.bluetooth.AbstractBluetooth import AbstractBluetooth

class BluetoothBlueZ_OS2008(AbstractBluetooth):

  def pre_init(self):
    self.friendly_name = 'BlueZ OS2008'
    self.dep_packages = {'bluez-utils': '3.28', 'osso-bluez-compat': '0.14'}
    adapter = Shell.get_command_output('dbus-send --system --dest=org.bluez --print-reply /org/bluez org.bluez.Manager.DefaultAdapter | tail -1 | sed \'s/^.*"\\(.*\\)".*$/\\1/\'').replace('\n', '')
    self.interfaces_map = {'BlueZ': ('org.bluez', adapter, 'org.bluez.Adapter')}
    self.export_signals = {'bluetooth_mode': {'path': adapter, 'dbus_interface': 'org.bluez.Adapter', 'signal_name': 'ModeChanged'}}

  def get_status(self):
    try:
      self.mode = str(self.interfaces['BlueZ'].GetMode())
    except:
      pass
    try:
      available_modes = self.interfaces['BlueZ'].ListAvailableModes()
      self.available_modes = [str(x) for x  in available_modes]
      del available_modes
    except:
      pass

  def mode_handler(self, signal):
    signal = str(signal)
    if signal in self.get_available_modes():
      self.mode = signal

  def get_mode(self):
    return self.mode

  def set_mode(self, mode):
    try:
      self.interfaces['BlueZ'].SetMode(mode)
      self.mode = str(self.interfaces['BlueZ'].GetMode())
    except:
      pass

  def get_available_modes(self):
    return self.available_modes
